// -*- c++ -*-
//  Generated by gtkmmproc from ./../scale.gen_h -- DO NOT MODIFY!
#ifndef _GTKMM_SCALE_H
#define _GTKMM_SCALE_H

/* $Id: scale.gen_h,v 1.46 2001/07/15 13:33:38 murrayc Exp $ */

/* scale.h
 *
 * Copyright (C) 1998-1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/range.h>
#include <gtk/gtkscale.h>
#include <gtk/gtkhscale.h>
#include <gtk/gtkvscale.h>

namespace Gtk {
class Scale;
class Scale_Class;
}
namespace Gtk { Gtk::Scale *wrap (GtkScale *o); }
namespace Gtk {
class VScale;
class VScale_Class;
}
namespace Gtk { Gtk::VScale *wrap (GtkVScale *o); }
namespace Gtk {
class HScale;
class HScale_Class;
}
namespace Gtk { Gtk::HScale *wrap (GtkHScale *o); }
namespace Gtk
{
//: A base class for GtkHScale and GtkVScale.
//- The {\class Gtk::Scale} widget is an abstract class, used only for deriving the subclasses {Gtk::HScale::} and {Gtk::VScale::}.
class Scale : public Range {

public:
  typedef Scale          CppObjectType;
  typedef Scale_Class    CppClassType;
  typedef GtkScale           BaseObjectType;
  typedef GtkScaleClass      BaseClassType;

private:
  friend class Scale_Class;
  static CppClassType scale_class;

  Scale(const Scale&);
  Scale& operator=(const Scale&); // not implemented

protected:
  void   initialize_class();
  explicit Scale(GtkScale *castitem);

public:
  static GtkType get_type();
  GtkScale* gtkobj()             { return (GtkScale*)(gtkobject); }
  const GtkScale* gtkobj() const { return (GtkScale*)(gtkobject); }
  static bool isA(Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Scale();

private:

public:




  gint get_digits () const;
  //: Sets the number of decimal places that are displayed in the value.
  //- {\var digits}: The number of decimal places to display, e.g. use 1 to display 1.0, 2 to display 1.00 etc.

  void set_digits(gint digits);

  //: Specifies whether the current value is displayed as a string next to the slider.

  void set_draw_value(gint draw_value);

  //: Sets the position in which the current value is displayed.
  //- {\var pos}: The position in which the current value is displayed. Possible values are:
  //- {\enum GTK_POS_LEFT}, {\enum GTK_POS_RIGHT}, {\enum GTK_POS_TOP}, or
  //- {\enum GTK_POS_BOTTOM}.

  void set_value_pos(GtkPositionType pos);

  //: An internal function used to get the maximum width needed to display the value string.
  //- {\var Returns}: The maximum width needed to display the value string.

  gint get_value_width() const;


protected:
  Scale();

public:

  union
    {
      CppObjectType * scale_self;
      Gtk::EmitProxySignal0<void,CppObjectType,BaseObjectType,0,&gtk_scale_draw_value> draw_value;
    };

protected:
  // impl functions
    virtual void draw_value_impl();

};

//: A vertical slider widget for selecting a value from a range.
//- The {\class Gtk::VScale} widget is used to allow the user to select a value
//- using a horizontal slider. A {Gtk::Adjustment::} is used to set the
//- initial value, the lower and upper bounds, and the step and page increments.
//-
//- The position to show the current value, and the number of decimal places shown can be
//- set using the parent {Gtk::Scale::} class's functions.
class VScale : public Scale {

public:
  typedef VScale          CppObjectType;
  typedef VScale_Class    CppClassType;
  typedef GtkVScale           BaseObjectType;
  typedef GtkVScaleClass      BaseClassType;

private:
  friend class VScale_Class;
  static CppClassType vscale_class;

  VScale(const VScale&);
  VScale& operator=(const VScale&); // not implemented

protected:
  void   initialize_class();
  explicit VScale(GtkVScale *castitem);

public:
  static GtkType get_type();
  GtkVScale* gtkobj()             { return (GtkVScale*)(gtkobject); }
  const GtkVScale* gtkobj() const { return (GtkVScale*)(gtkobject); }
  static bool isA(Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~VScale();

private:

public:
  explicit VScale(Adjustment &adjustment);
  VScale();

public:

protected:
  // impl functions

};


//: A horizontal slider widget for selecting a value from a range.
//- The {\class Gtk::HScale} widget is used to allow the user to select a value
//- using a horizontal slider. A {Gtk::Adjustment::} is used to set the
//- initial value, the lower and upper bounds, and the step and page increments.
//-
//- The position to show the current value, and the number of decimal places shown can be
//- set using the parent {Gtk::Scale::} class's functions.
class HScale : public Scale {

public:
  typedef HScale          CppObjectType;
  typedef HScale_Class    CppClassType;
  typedef GtkHScale           BaseObjectType;
  typedef GtkHScaleClass      BaseClassType;

private:
  friend class HScale_Class;
  static CppClassType hscale_class;

  HScale(const HScale&);
  HScale& operator=(const HScale&); // not implemented

protected:
  void   initialize_class();
  explicit HScale(GtkHScale *castitem);

public:
  static GtkType get_type();
  GtkHScale* gtkobj()             { return (GtkHScale*)(gtkobject); }
  const GtkHScale* gtkobj() const { return (GtkHScale*)(gtkobject); }
  static bool isA(Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~HScale();

private:

public:
  explicit HScale(Adjustment &adjustment);
  HScale();

public:

protected:
  // impl functions

};

}


//+ PROPERTIES(Gtk_Scale)
//. name: draw_value
//. type: guint:1
//. get:
//. set:
//. desc:

//. name: value_pos
//. type: guint:2
//. get:
//. set:
//. desc:

#endif
